Crossfilter Dashboard in JavaScript

Using ApexCharts with JavaScript

This Crossfilter Dashboard example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Deterministic trade records. outcome is derived from the fluctuation sign,
// so brushing the fluctuation histogram visibly reshapes the outcome donut.
function tradesData() {
  var quarters = ['Q1', 'Q2', 'Q3', 'Q4']
  var days = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri']
  var out = []
  for (var i = 0; i < 120; i++) {
    var pct =
      3.0 * Math.sin(i / 5.0) +
      1.3 * Math.sin(i / 1.7) +
      0.4 * Math.cos(i / 3.1)
    var vol = Math.round(120 + 70 * Math.sin(i / 6.0) + 40 * Math.cos(i / 2.3))
    out.push({
      id: i + 1,
      quarter: quarters[Math.floor(i / 30) % 4],
      day: days[(i * 3) % 5],
      outcome: pct >= 0 ? 'Gain' : 'Loss',
      pct: Math.round(pct * 100) / 100,
      volume: Math.max(20, vol),
    })
  }
  return out
}

// Register the shared record set BEFORE the charts are constructed.
ApexCharts.crossfilter({ id: 'trades', records: tradesData() })

var options = {
  series: [],
  chart: {
    id: 'byQuarter',
    type: 'donut',
    height: 260,
    fontFamily: 'Helvetica, Arial, sans-serif',
    animations: { speed: 450 },
    link: {
      id: 'trades',
      dimension: function (r) {
        return r.quarter
      },
      reduce: 'count',
      dimOpacity: 0.18,
    },
  },
  title: { text: 'Quarter', align: 'left' },
  legend: { position: 'bottom', fontSize: '12px' },
  plotOptions: { pie: { expandOnClick: false } },
  dataLabels: {
    enabled: true,
    formatter: function (v, o) {
      return o.w.config.series[o.seriesIndex]
    },
  },
  colors: ['#2563EB', '#0ea5e9', '#22c55e', '#f59e0b'],
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

var options1 = {
  series: [],
  chart: {
    id: 'byOutcome',
    type: 'donut',
    height: 260,
    fontFamily: 'Helvetica, Arial, sans-serif',
    animations: { speed: 450 },
    link: {
      id: 'trades',
      dimension: function (r) {
        return r.outcome
      },
      reduce: 'count',
      dimOpacity: 0.18,
    },
  },
  title: { text: 'Outcome', align: 'left' },
  legend: { position: 'bottom', fontSize: '12px' },
  plotOptions: { pie: { expandOnClick: false } },
  dataLabels: {
    enabled: true,
    formatter: function (v, o) {
      return o.w.config.series[o.seriesIndex]
    },
  },
  colors: ['#22c55e', '#ef4444'],
}

var chart1 = new ApexCharts(document.querySelector('#chart2'), options1)
chart1.render()

var options2 = {
  series: [],
  chart: {
    id: 'byDay',
    type: 'bar',
    height: 260,
    fontFamily: 'Helvetica, Arial, sans-serif',
    animations: { speed: 450 },
    link: {
      id: 'trades',
      dimension: function (r) {
        return r.day
      },
      reduce: 'count',
      seriesName: 'Trades',
      dimOpacity: 0.18,
    },
  },
  title: { text: 'Day of week', align: 'left' },
  plotOptions: {
    bar: { columnWidth: '55%', borderRadius: 3, distributed: true },
  },
  legend: { show: false },
  dataLabels: { enabled: false },
  colors: ['#2563EB', '#0ea5e9', '#22c55e', '#f59e0b', '#F43F5E'],
}

var chart2 = new ApexCharts(document.querySelector('#chart3'), options2)
chart2.render()

var options3 = {
  series: [],
  chart: {
    id: 'byFluctuation',
    type: 'bar',
    height: 240,
    fontFamily: 'Helvetica, Arial, sans-serif',
    animations: { speed: 400 },
    zoom: { enabled: false },
    selection: { enabled: true },
    toolbar: {
      autoSelected: 'selection',
      tools: {
        selection: true,
        zoom: false,
        pan: false,
        reset: false,
        download: false,
      },
    },
    link: {
      id: 'trades',
      dimension: function (r) {
        return r.pct
      },
      bins: { count: 26 },
      dimOpacity: 0.16,
    },
  },
  title: { text: 'Fluctuation % (brush a range)', align: 'left' },
  plotOptions: { bar: { columnWidth: '92%' } },
  dataLabels: { enabled: false },
  xaxis: {
    type: 'numeric',
    tickAmount: 8,
    labels: {
      formatter: function (v) {
        return Number(v).toFixed(1)
      },
    },
  },
  colors: ['#2563EB'],
}

var chart3 = new ApexCharts(document.querySelector('#chart4'), options3)
chart3.render()

var options4 = {
  series: [],
  chart: {
    id: 'byVolume',
    type: 'bar',
    height: 240,
    fontFamily: 'Helvetica, Arial, sans-serif',
    animations: { speed: 400 },
    zoom: { enabled: false },
    selection: { enabled: true },
    toolbar: {
      autoSelected: 'selection',
      tools: {
        selection: true,
        zoom: false,
        pan: false,
        reset: false,
        download: false,
      },
    },
    link: {
      id: 'trades',
      dimension: function (r) {
        return r.volume
      },
      bins: { count: 22 },
      dimOpacity: 0.16,
    },
  },
  title: { text: 'Volume (brush a range)', align: 'left' },
  plotOptions: { bar: { columnWidth: '92%' } },
  dataLabels: { enabled: false },
  xaxis: {
    type: 'numeric',
    tickAmount: 8,
    labels: {
      formatter: function (v) {
        return Math.round(v)
      },
    },
  },
  colors: ['#0ea5e9'],
}

var chart4 = new ApexCharts(document.querySelector('#chart5'), options4)
chart4.render()

// Five charts (chart..chart4) + a live data table, all over the 'trades' set.
var cf = ApexCharts.getCrossfilter('trades')
var readout = document.getElementById('cfd-readout')

if (cf) {
  // Bind the data table to the filtered rows; it re-renders on every change.
  cf.dataTable(document.getElementById('cfd-table'), {
    columns: [
      { field: 'id', label: '#' },
      { field: 'quarter', label: 'Quarter' },
      { field: 'day', label: 'Day' },
      { field: 'outcome', label: 'Outcome' },
      {
        field: 'pct',
        label: 'Fluctuation %',
        format: function (v) {
          return v.toFixed(2) + '%'
        },
      },
      { field: 'volume', label: 'Volume' },
    ],
  })

  cf.on('change', function (state) {
    var ids = Object.keys(state.filters)
    var label = ids.length ? ids.join(', ') : 'none'
    readout.textContent =
      state.filteredCount +
      ' / ' +
      state.total +
      ' trades   (active: ' +
      label +
      ')'
  })

  // Seed the readout with the unfiltered totals.
  var s = cf.state()
  readout.textContent =
    s.filteredCount + ' / ' + s.total + ' trades   (active: none)'
}

document.getElementById('cfd-reset').addEventListener('click', function () {
  if (cf) cf.reset()
})

Crossfilter Dashboard in Angular

Using ApexCharts with Angular

This Crossfilter Dashboard example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide
import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private tradesData = (): any => {
        var quarters = ['Q1', 'Q2', 'Q3', 'Q4']
        var days = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri']
        var out = []
        for (var i = 0; i < 120; i++) {
          var pct =
            3.0 * Math.sin(i / 5.0) +
            1.3 * Math.sin(i / 1.7) +
            0.4 * Math.cos(i / 3.1)
          var vol = Math.round(120 + 70 * Math.sin(i / 6.0) + 40 * Math.cos(i / 2.3))
          out.push({
            id: i + 1,
            quarter: quarters[Math.floor(i / 30) % 4],
            day: days[(i * 3) % 5],
            outcome: pct >= 0 ? 'Gain' : 'Loss',
            pct: Math.round(pct * 100) / 100,
            volume: Math.max(20, vol),
          })
        }
        return out
      };

  private cf: any = ApexCharts.getCrossfilter('trades');

  private readout: any = document.getElementById('cfd-readout');

  public chartOptions: Partial<ChartOptions> = {
          series: [],
          chart: {
            id: 'byQuarter',
            type: 'donut',
            height: 260,
            fontFamily: 'Helvetica, Arial, sans-serif',
            animations: { speed: 450 },
            link: {
              id: 'trades',
              dimension: (r) => {
                return r.quarter
              },
              reduce: 'count',
              dimOpacity: 0.18,
            },
          },
          title: { text: 'Quarter', align: 'left' },
          legend: { position: 'bottom', fontSize: '12px' },
          plotOptions: { pie: { expandOnClick: false } },
          dataLabels: {
            enabled: true,
            formatter: (v, o) => {
              return o.w.config.series[o.seriesIndex]
            },
          },
          colors: ['#2563EB', '#0ea5e9', '#22c55e', '#f59e0b'],
        };

  public chartOptions2: Partial<ChartOptions> = {
          series: [],
          chart: {
            id: 'byOutcome',
            type: 'donut',
            height: 260,
            fontFamily: 'Helvetica, Arial, sans-serif',
            animations: { speed: 450 },
            link: {
              id: 'trades',
              dimension: (r) => {
                return r.outcome
              },
              reduce: 'count',
              dimOpacity: 0.18,
            },
          },
          title: { text: 'Outcome', align: 'left' },
          legend: { position: 'bottom', fontSize: '12px' },
          plotOptions: { pie: { expandOnClick: false } },
          dataLabels: {
            enabled: true,
            formatter: (v, o) => {
              return o.w.config.series[o.seriesIndex]
            },
          },
          colors: ['#22c55e', '#ef4444'],
        };

  public chartOptions3: Partial<ChartOptions> = {
          series: [],
          chart: {
            id: 'byDay',
            type: 'bar',
            height: 260,
            fontFamily: 'Helvetica, Arial, sans-serif',
            animations: { speed: 450 },
            link: {
              id: 'trades',
              dimension: (r) => {
                return r.day
              },
              reduce: 'count',
              seriesName: 'Trades',
              dimOpacity: 0.18,
            },
          },
          title: { text: 'Day of week', align: 'left' },
          plotOptions: {
            bar: { columnWidth: '55%', borderRadius: 3, distributed: true },
          },
          legend: { show: false },
          dataLabels: { enabled: false },
          colors: ['#2563EB', '#0ea5e9', '#22c55e', '#f59e0b', '#F43F5E'],
        };

  public chartOptions4: Partial<ChartOptions> = {
          series: [],
          chart: {
            id: 'byFluctuation',
            type: 'bar',
            height: 240,
            fontFamily: 'Helvetica, Arial, sans-serif',
            animations: { speed: 400 },
            zoom: { enabled: false },
            selection: { enabled: true },
            toolbar: {
              autoSelected: 'selection',
              tools: {
                selection: true,
                zoom: false,
                pan: false,
                reset: false,
                download: false,
              },
            },
            link: {
              id: 'trades',
              dimension: (r) => {
                return r.pct
              },
              bins: { count: 26 },
              dimOpacity: 0.16,
            },
          },
          title: { text: 'Fluctuation % (brush a range)', align: 'left' },
          plotOptions: { bar: { columnWidth: '92%' } },
          dataLabels: { enabled: false },
          xaxis: {
            type: 'numeric',
            tickAmount: 8,
            labels: {
              formatter: (v) => {
                return Number(v).toFixed(1)
              },
            },
          },
          colors: ['#2563EB'],
        };

  public chartOptions5: Partial<ChartOptions> = {
          series: [],
          chart: {
            id: 'byVolume',
            type: 'bar',
            height: 240,
            fontFamily: 'Helvetica, Arial, sans-serif',
            animations: { speed: 400 },
            zoom: { enabled: false },
            selection: { enabled: true },
            toolbar: {
              autoSelected: 'selection',
              tools: {
                selection: true,
                zoom: false,
                pan: false,
                reset: false,
                download: false,
              },
            },
            link: {
              id: 'trades',
              dimension: (r) => {
                return r.volume
              },
              bins: { count: 22 },
              dimOpacity: 0.16,
            },
          },
          title: { text: 'Volume (brush a range)', align: 'left' },
          plotOptions: { bar: { columnWidth: '92%' } },
          dataLabels: { enabled: false },
          xaxis: {
            type: 'numeric',
            tickAmount: 8,
            labels: {
              formatter: (v) => {
                return Math.round(v)
              },
            },
          },
          colors: ['#0ea5e9'],
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    ApexCharts.crossfilter({ id: 'trades', records: this.tradesData() })

    document.getElementById('cfd-reset').addEventListener('click', () => {
            if (this.cf) this.cf.reset()
          })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Crossfilter Dashboard in Vue

Using ApexCharts with Vue

This Crossfilter Dashboard example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="cfd">
      <div class="cfd-bar">
        <button id="cfd-reset">Reset all filters</button>
        <span class="readout" id="cfd-readout"></span>
      </div>

      <div class="cfd-grid">
        <div class="cfd-card">
          <div id="chart">
            <apexchart
              type="donut"
              height="260"
              :options="chartOptions"
              :series="series"
            ></apexchart>
          </div>
        </div>
        <div class="cfd-card">
          <div id="chart2">
            <apexchart
              type="donut"
              height="260"
              :options="chartOptions1"
              :series="series1"
            ></apexchart>
          </div>
        </div>
        <div class="cfd-card">
          <div id="chart3">
            <apexchart
              type="bar"
              height="260"
              :options="chartOptions2"
              :series="series2"
            ></apexchart>
          </div>
        </div>
        <div class="cfd-card brush">
          <div id="chart4">
            <apexchart
              type="bar"
              height="240"
              :options="chartOptions3"
              :series="series3"
            ></apexchart>
          </div>
        </div>
        <div class="cfd-card brush">
          <div id="chart5">
            <apexchart
              type="bar"
              height="240"
              :options="chartOptions4"
              :series="series4"
            ></apexchart>
          </div>
        </div>
      </div>

      <div class="cfd-tablewrap" id="cfd-table"></div>

      <div class="cfd-note">
        Five views over one record set registered with
        <code>ApexCharts.crossfilter(&#123; id, records &#125;)</code>. The
        donuts and the day bar filter by <b>clicking a bucket</b>; the two
        histograms filter by <b>brushing a range</b> (they set
        <code>chart.selection.enabled</code>). Every selection combines: each
        chart re-aggregates over the rows passing all the <i>other</i> charts'
        filters (never its own), and the table below lists exactly those rows.
        Try brushing the fluctuation histogram and watch the outcome donut
        reshape. <b>Reset all filters</b> clears everything.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

import 'apexcharts/features/link'

// Deterministic trade records. outcome is derived from the fluctuation sign,
// so brushing the fluctuation histogram visibly reshapes the outcome donut.
function tradesData() {
  var quarters = ['Q1', 'Q2', 'Q3', 'Q4']
  var days = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri']
  var out = []
  for (var i = 0; i < 120; i++) {
    var pct =
      3.0 * Math.sin(i / 5.0) + 1.3 * Math.sin(i / 1.7) + 0.4 * Math.cos(i / 3.1)
    var vol = Math.round(120 + 70 * Math.sin(i / 6.0) + 40 * Math.cos(i / 2.3))
    out.push({
      id: i + 1,
      quarter: quarters[Math.floor(i / 30) % 4],
      day: days[(i * 3) % 5],
      outcome: pct >= 0 ? 'Gain' : 'Loss',
      pct: Math.round(pct * 100) / 100,
      volume: Math.max(20, vol),
    })
  }
  return out
}

// Register the shared record set BEFORE the charts are constructed.
ApexCharts.crossfilter({ id: 'trades', records: tradesData() })

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [],
chartOptions: {
chart: {
  id: 'byQuarter',
  type: 'donut',
  height: 260,
  fontFamily: 'Helvetica, Arial, sans-serif',
  animations: { speed: 450 },
  link: { id: 'trades', dimension: function (r) { return r.quarter }, reduce: 'count', dimOpacity: 0.18 },
},
title: { text: 'Quarter', align: 'left' },
legend: { position: 'bottom', fontSize: '12px' },
plotOptions: { pie: { expandOnClick: false } },
dataLabels: { enabled: true, formatter: function (v, o) { return o.w.config.series[o.seriesIndex] } },
colors: ['#2563EB', '#0ea5e9', '#22c55e', '#f59e0b'],
},
series1: [],
chartOptions1: {
chart: {
  id: 'byOutcome',
  type: 'donut',
  height: 260,
  fontFamily: 'Helvetica, Arial, sans-serif',
  animations: { speed: 450 },
  link: { id: 'trades', dimension: function (r) { return r.outcome }, reduce: 'count', dimOpacity: 0.18 },
},
title: { text: 'Outcome', align: 'left' },
legend: { position: 'bottom', fontSize: '12px' },
plotOptions: { pie: { expandOnClick: false } },
dataLabels: { enabled: true, formatter: function (v, o) { return o.w.config.series[o.seriesIndex] } },
colors: ['#22c55e', '#ef4444'],
},
series2: [],
chartOptions2: {
chart: {
  id: 'byDay',
  type: 'bar',
  height: 260,
  fontFamily: 'Helvetica, Arial, sans-serif',
  animations: { speed: 450 },
  link: { id: 'trades', dimension: function (r) { return r.day }, reduce: 'count', seriesName: 'Trades', dimOpacity: 0.18 },
},
title: { text: 'Day of week', align: 'left' },
plotOptions: { bar: { columnWidth: '55%', borderRadius: 3, distributed: true } },
legend: { show: false },
dataLabels: { enabled: false },
colors: ['#2563EB', '#0ea5e9', '#22c55e', '#f59e0b', '#F43F5E'],
},
series3: [],
chartOptions3: {
chart: {
  id: 'byFluctuation',
  type: 'bar',
  height: 240,
  fontFamily: 'Helvetica, Arial, sans-serif',
  animations: { speed: 400 },
  zoom: { enabled: false },
  selection: { enabled: true },
  toolbar: { autoSelected: 'selection', tools: { selection: true, zoom: false, pan: false, reset: false, download: false } },
  link: { id: 'trades', dimension: function (r) { return r.pct }, bins: { count: 26 }, dimOpacity: 0.16 },
},
title: { text: 'Fluctuation % (brush a range)', align: 'left' },
plotOptions: { bar: { columnWidth: '92%' } },
dataLabels: { enabled: false },
xaxis: { type: 'numeric', tickAmount: 8, labels: { formatter: function (v) { return Number(v).toFixed(1) } } },
colors: ['#2563EB'],
},
series4: [],
chartOptions4: {
chart: {
  id: 'byVolume',
  type: 'bar',
  height: 240,
  fontFamily: 'Helvetica, Arial, sans-serif',
  animations: { speed: 400 },
  zoom: { enabled: false },
  selection: { enabled: true },
  toolbar: { autoSelected: 'selection', tools: { selection: true, zoom: false, pan: false, reset: false, download: false } },
  link: { id: 'trades', dimension: function (r) { return r.volume }, bins: { count: 22 }, dimOpacity: 0.16 },
},
title: { text: 'Volume (brush a range)', align: 'left' },
plotOptions: { bar: { columnWidth: '92%' } },
dataLabels: { enabled: false },
xaxis: { type: 'numeric', tickAmount: 8, labels: { formatter: function (v) { return Math.round(v) } } },
colors: ['#0ea5e9'],
},
cfTrades: null,
}
},
mounted: function () {
  // Five linked views (byQuarter..byVolume) + a live data table, all over the
  // shared 'trades' record set (registered in the head script). The wrapper owns
  // the render, so poll until every chart instance and the crossfilter exist,
  // then wire the table + readout + reset exactly as the vanilla build does.
  var me = this
  me._onReset = function () {
    if (me.cfTrades) me.cfTrades.reset()
  }
  var timer = window.setInterval(function () {
    var cf = ApexCharts.getCrossfilter('trades')
    var ready =
      cf &&
      ApexCharts.getChartByID('byQuarter') &&
      ApexCharts.getChartByID('byOutcome') &&
      ApexCharts.getChartByID('byDay') &&
      ApexCharts.getChartByID('byFluctuation') &&
      ApexCharts.getChartByID('byVolume')
    if (!ready) return
    window.clearInterval(timer)
    me._timer = null
    me.cfTrades = cf

    var readout = document.getElementById('cfd-readout')

    // Bind the data table to the filtered rows; it re-renders on every change.
    me._table = cf.dataTable(document.getElementById('cfd-table'), {
      columns: [
        { field: 'id', label: '#' },
        { field: 'quarter', label: 'Quarter' },
        { field: 'day', label: 'Day' },
        { field: 'outcome', label: 'Outcome' },
        { field: 'pct', label: 'Fluctuation %', format: function (v) { return v.toFixed(2) + '%' } },
        { field: 'volume', label: 'Volume' },
      ],
    })

    me._offChange = cf.on('change', function (state) {
      var ids = Object.keys(state.filters)
      var label = ids.length ? ids.join(', ') : 'none'
      readout.textContent =
        state.filteredCount + ' / ' + state.total + ' trades   (active: ' + label + ')'
    })

    // Seed the readout with the unfiltered totals.
    var s = cf.state()
    readout.textContent = s.filteredCount + ' / ' + s.total + ' trades   (active: none)'

    document.getElementById('cfd-reset').addEventListener('click', me._onReset)
  }, 50)
  me._timer = timer
},
beforeDestroy: function () {
  if (this._timer) window.clearInterval(this._timer)
  if (this._offChange) this._offChange()
  if (this._table) this._table.destroy()
  var btn = document.getElementById('cfd-reset')
  if (btn && this._onReset) btn.removeEventListener('click', this._onReset)
},,
}
</script>

<style>
.cfd {
  max-width: 700px;
  margin: 10px auto;
  font-family: Helvetica, Arial, sans-serif;
  color: #1f2430;
}
.cfd-bar {
  display: flex;
  gap: 12px;
  align-items: center;
  flex-wrap: wrap;
  margin: 4px 6px 12px;
}
.cfd-bar button {
  padding: 6px 13px;
  cursor: pointer;
  border: 1px solid #2563eb;
  color: #4338ca;
  background: #fff;
  border-radius: 6px;
  font-size: 13px;
  font-weight: 600;
}
.cfd-bar .readout {
  font-family: monospace;
  font-size: 13px;
  color: #445;
}
.cfd-grid {
  display: grid;
  /* Auto-fit reflows the three categorical charts from 3 columns down to 2,
       then 1, as the container narrows, so they never get crushed at ~700px. */
  grid-template-columns: repeat(auto-fit, minmax(190px, 1fr));
  gap: 8px;
}
.cfd-card {
  border: 1px solid #eef;
  border-radius: 8px;
  padding: 6px;
}
/* The two brush histograms always take a full row, whatever the column count. */
.cfd-card.brush {
  grid-column: 1 / -1;
}
.cfd-tablewrap {
  margin: 12px 6px;
  max-height: 280px;
  overflow: auto;
  border: 1px solid #eef;
  border-radius: 8px;
}
.cfd-note {
  background: #eef2ff;
  border-left: 3px solid #2563eb;
  padding: 11px 15px;
  font-size: 13px;
  color: #234;
  border-radius: 2px;
  line-height: 1.6;
  margin: 12px 6px;
}
.cfd-note code {
  background: #dfe3ff;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Crossfilter Dashboard in React

Using ApexCharts with React

This Crossfilter Dashboard example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

import 'apexcharts/features/link'

// Deterministic trade records. outcome is derived from the fluctuation sign,
// so brushing the fluctuation histogram visibly reshapes the outcome donut.
function tradesData() {
  var quarters = ['Q1', 'Q2', 'Q3', 'Q4']
  var days = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri']
  var out = []
  for (var i = 0; i < 120; i++) {
    var pct =
      3.0 * Math.sin(i / 5.0) +
      1.3 * Math.sin(i / 1.7) +
      0.4 * Math.cos(i / 3.1)
    var vol = Math.round(120 + 70 * Math.sin(i / 6.0) + 40 * Math.cos(i / 2.3))
    out.push({
      id: i + 1,
      quarter: quarters[Math.floor(i / 30) % 4],
      day: days[(i * 3) % 5],
      outcome: pct >= 0 ? 'Gain' : 'Loss',
      pct: Math.round(pct * 100) / 100,
      volume: Math.max(20, vol),
    })
  }
  return out
}

// Register the shared record set BEFORE the charts are constructed.
ApexCharts.crossfilter({ id: 'trades', records: tradesData() })

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [],
    options: {
      chart: {
        id: 'byQuarter',
        type: 'donut',
        height: 260,
        fontFamily: 'Helvetica, Arial, sans-serif',
        animations: { speed: 450 },
        link: {
          id: 'trades',
          dimension: function (r) {
            return r.quarter
          },
          reduce: 'count',
          dimOpacity: 0.18,
        },
      },
      title: { text: 'Quarter', align: 'left' },
      legend: { position: 'bottom', fontSize: '12px' },
      plotOptions: { pie: { expandOnClick: false } },
      dataLabels: {
        enabled: true,
        formatter: function (v, o) {
          return o.w.config.series[o.seriesIndex]
        },
      },
      colors: ['#2563EB', '#0ea5e9', '#22c55e', '#f59e0b'],
    },
    series1: [],
    options1: {
      chart: {
        id: 'byOutcome',
        type: 'donut',
        height: 260,
        fontFamily: 'Helvetica, Arial, sans-serif',
        animations: { speed: 450 },
        link: {
          id: 'trades',
          dimension: function (r) {
            return r.outcome
          },
          reduce: 'count',
          dimOpacity: 0.18,
        },
      },
      title: { text: 'Outcome', align: 'left' },
      legend: { position: 'bottom', fontSize: '12px' },
      plotOptions: { pie: { expandOnClick: false } },
      dataLabels: {
        enabled: true,
        formatter: function (v, o) {
          return o.w.config.series[o.seriesIndex]
        },
      },
      colors: ['#22c55e', '#ef4444'],
    },
    series2: [],
    options2: {
      chart: {
        id: 'byDay',
        type: 'bar',
        height: 260,
        fontFamily: 'Helvetica, Arial, sans-serif',
        animations: { speed: 450 },
        link: {
          id: 'trades',
          dimension: function (r) {
            return r.day
          },
          reduce: 'count',
          seriesName: 'Trades',
          dimOpacity: 0.18,
        },
      },
      title: { text: 'Day of week', align: 'left' },
      plotOptions: {
        bar: { columnWidth: '55%', borderRadius: 3, distributed: true },
      },
      legend: { show: false },
      dataLabels: { enabled: false },
      colors: ['#2563EB', '#0ea5e9', '#22c55e', '#f59e0b', '#F43F5E'],
    },
    series3: [],
    options3: {
      chart: {
        id: 'byFluctuation',
        type: 'bar',
        height: 240,
        fontFamily: 'Helvetica, Arial, sans-serif',
        animations: { speed: 400 },
        zoom: { enabled: false },
        selection: { enabled: true },
        toolbar: {
          autoSelected: 'selection',
          tools: {
            selection: true,
            zoom: false,
            pan: false,
            reset: false,
            download: false,
          },
        },
        link: {
          id: 'trades',
          dimension: function (r) {
            return r.pct
          },
          bins: { count: 26 },
          dimOpacity: 0.16,
        },
      },
      title: { text: 'Fluctuation % (brush a range)', align: 'left' },
      plotOptions: { bar: { columnWidth: '92%' } },
      dataLabels: { enabled: false },
      xaxis: {
        type: 'numeric',
        tickAmount: 8,
        labels: {
          formatter: function (v) {
            return Number(v).toFixed(1)
          },
        },
      },
      colors: ['#2563EB'],
    },
    series4: [],
    options4: {
      chart: {
        id: 'byVolume',
        type: 'bar',
        height: 240,
        fontFamily: 'Helvetica, Arial, sans-serif',
        animations: { speed: 400 },
        zoom: { enabled: false },
        selection: { enabled: true },
        toolbar: {
          autoSelected: 'selection',
          tools: {
            selection: true,
            zoom: false,
            pan: false,
            reset: false,
            download: false,
          },
        },
        link: {
          id: 'trades',
          dimension: function (r) {
            return r.volume
          },
          bins: { count: 22 },
          dimOpacity: 0.16,
        },
      },
      title: { text: 'Volume (brush a range)', align: 'left' },
      plotOptions: { bar: { columnWidth: '92%' } },
      dataLabels: { enabled: false },
      xaxis: {
        type: 'numeric',
        tickAmount: 8,
        labels: {
          formatter: function (v) {
            return Math.round(v)
          },
        },
      },
      colors: ['#0ea5e9'],
    },
  })

  React.useEffect(() => {
    // Five linked views (byQuarter..byVolume) + a live data table, all over the
    // shared 'trades' record set (registered in the head script). The wrapper owns
    // the render, so poll until every chart instance and the crossfilter exist,
    // then wire the table + readout + reset exactly as the vanilla build does.
    let cf
    let table
    let offChange
    const onReset = () => {
      if (cf) cf.reset()
    }

    const timer = window.setInterval(() => {
      cf = ApexCharts.getCrossfilter('trades')
      const ready =
        cf &&
        ApexCharts.getChartByID('byQuarter') &&
        ApexCharts.getChartByID('byOutcome') &&
        ApexCharts.getChartByID('byDay') &&
        ApexCharts.getChartByID('byFluctuation') &&
        ApexCharts.getChartByID('byVolume')
      if (!ready) return
      window.clearInterval(timer)

      const readout = document.getElementById('cfd-readout')

      // Bind the data table to the filtered rows; it re-renders on every change.
      table = cf.dataTable(document.getElementById('cfd-table'), {
        columns: [
          { field: 'id', label: '#' },
          { field: 'quarter', label: 'Quarter' },
          { field: 'day', label: 'Day' },
          { field: 'outcome', label: 'Outcome' },
          {
            field: 'pct',
            label: 'Fluctuation %',
            format: (v) => v.toFixed(2) + '%',
          },
          { field: 'volume', label: 'Volume' },
        ],
      })

      offChange = cf.on('change', (state) => {
        const ids = Object.keys(state.filters)
        const label = ids.length ? ids.join(', ') : 'none'
        readout.textContent =
          state.filteredCount +
          ' / ' +
          state.total +
          ' trades   (active: ' +
          label +
          ')'
      })

      // Seed the readout with the unfiltered totals.
      const s = cf.state()
      readout.textContent =
        s.filteredCount + ' / ' + s.total + ' trades   (active: none)'

      document.getElementById('cfd-reset').addEventListener('click', onReset)
    }, 50)

    return () => {
      window.clearInterval(timer)
      if (offChange) offChange()
      if (table) table.destroy()
      const btn = document.getElementById('cfd-reset')
      if (btn) btn.removeEventListener('click', onReset)
    }
  }, [])

  return (
    <div>
      <div className="cfd">
        <div className="cfd-bar">
          <button id="cfd-reset">Reset all filters</button>
          <span className="readout" id="cfd-readout"></span>
        </div>

        <div className="cfd-grid">
          <div className="cfd-card">
            <div id="chart">
              <ReactApexChart
                options={state.options}
                series={state.series}
                type="donut"
                height={260}
              />
            </div>
          </div>
          <div className="cfd-card">
            <div id="chart2">
              <ReactApexChart
                options={state.options1}
                series={state.series1}
                type="donut"
                height={260}
              />
            </div>
          </div>
          <div className="cfd-card">
            <div id="chart3">
              <ReactApexChart
                options={state.options2}
                series={state.series2}
                type="bar"
                height={260}
              />
            </div>
          </div>
          <div className="cfd-card brush">
            <div id="chart4">
              <ReactApexChart
                options={state.options3}
                series={state.series3}
                type="bar"
                height={240}
              />
            </div>
          </div>
          <div className="cfd-card brush">
            <div id="chart5">
              <ReactApexChart
                options={state.options4}
                series={state.series4}
                type="bar"
                height={240}
              />
            </div>
          </div>
        </div>

        <div className="cfd-tablewrap" id="cfd-table"></div>

        <div className="cfd-note">
          Five views over one record set registered with
          <code>ApexCharts.crossfilter(&#123; id, records &#125;)</code>. The
          donuts and the day bar filter by <b>clicking a bucket</b>; the two
          histograms filter by
          <b>brushing a range</b> (they set <code>chart.selection.enabled</code>
          ). Every selection combines: each chart re-aggregates over the rows
          passing all the <i>other</i> charts' filters (never its own), and the
          table below lists exactly those rows. Try brushing the fluctuation
          histogram and watch the outcome donut reshape.{' '}
          <b>Reset all filters</b> clears everything.
        </div>
      </div>
    </div>
  )
}

export default ApexChart